/* common.cc
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015 Askar Almatov

    This file is part of Libiclass. 
    
    Libiclass is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.
    
    Libiclass is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.
    
    You should have received a copy of the GNU General Public License along with Libiclass. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include <cassert>
#include <libiclass/common>

using namespace iclass;

/**************************************************************************************************************/
commont::commont()
{
    pthread_mutexattr_t mutexattr;
    
    pthread_mutexattr_init( &mutexattr );
    assert( pthread_mutexattr_settype(&mutexattr, PTHREAD_MUTEX_RECURSIVE) == 0);
    pthread_mutex_init( &__mutex, &mutexattr );
    pthread_mutexattr_destroy( &mutexattr );
}

/**************************************************************************************************************/
commont::~commont()
{
    // Only EBUSY mutex can be destroyed because may be access to unlocked destructing data

    //assert( pthread_mutex_destroy(&__mutex) == EBUSY );
    pthread_mutex_destroy( &__mutex );
}

/**************************************************************************************************************/
void
commont::lock() const
{
    assert( pthread_mutex_lock(&__mutex) == 0 );
}

/**************************************************************************************************************/
void
commont::unlock() const
{
    assert( pthread_mutex_unlock(&__mutex) == 0 );
}

