/* daysmagictbl.cc
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015 Askar Almatov

    This file is part of Libiclass. 
    
    Libiclass is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.
    
    Libiclass is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.
    
    You should have received a copy of the GNU General Public License along with Libiclass. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include <fstream>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <libiclass/time>

using namespace iclass;

/**************************************************************************************************************/
int
main()
{
    long  ddowndays;
    long  downdays = -365;
    long  days = 0;
    long  updays = 366;
    long  uupdays = 731;

    printf( "{\n    " );
        
    for ( int i=0; i<400; i++ )
    {
	ddowndays = downdays;
	downdays = days;
	days = updays;
	// updays += 365;
	updays = uupdays;
	uupdays +=365;
	
	if ( (i+2)%4 == 0 && ((i+2)%100 || (i+2)%400==0) )
	{
	    uupdays++;
	}

	long double  ddowndelta( ddowndays - ((long double)i-1)*(gtimet::MEANYEAR/86400) );
	long double  downdelta( downdays - ((long double)i)*(gtimet::MEANYEAR/86400) );
	long double  delta( days - ((long double)i+1)*(gtimet::MEANYEAR/86400) );
	long double  updelta( updays - ((long double)i+2)*(gtimet::MEANYEAR/86400) );
	long double  upupdelta( uupdays - ((long double)i+3)*(gtimet::MEANYEAR/86400) );
	long double  meandelta( (delta+ddowndelta+downdelta+updelta+upupdelta)/5 );
	
//	cout << i << " " << 1600+i << " " << days << " " << days-146097 << " ";
//	cout << ddowndelta << " " << downdelta << " " << delta << " " << updelta << " " << upupdelta << " ";
//	cout << endl;
//	cout << meandelta << " " << meandelta-delta << " " << 0.5155-meandelta << endl;
	printf( "%7.4fL", (float)(0.5-meandelta) );
	
	if ( i != 399 )
	{
	    printf( ", " );
	    
	    if ( i%10 == 9 )
	    {
		printf( "\n    " );
	    }
	}
	
	// cout << 0.5-meandelta << endl;
//	cout << delta << " " << olddelta << " " << meandelta << " ";
    }
    
    printf( "\n};\n" );
    
    return 0;
}
