/* timetest.h
****************************************************************************************************************
****************************************************************************************************************

    Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015 Askar Almatov

    This file is part of Libiclass. 
    
    Libiclass is free software: you can redistribute it and/or modify it under the terms of the GNU General
    Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
    option) any later version.
    
    Libiclass is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
    implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
    License for more details.
    
    You should have received a copy of the GNU General Public License along with Libiclass. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include <cmath>
#include <iostream>
#include <string>
#include <libiclass/time>

using namespace iclass;
using namespace std;

/**************************************************************************************************************/
struct timetestt : public ltimet
{
    using gtimet::operator =;
    using gtimet::_setgdays;
    using gtimet::_setgmday;
    using gtimet::_setgmonth;
    using gtimet::_setgyear;

    //----------------------------------------------------------------------------------------------------------
    timetestt() :
        ltimet( "-infinity" )
    {
    }

    //----------------------------------------------------------------------------------------------------------
    void
    debugout( FILE* Outf=stdout ) const
    {
    	fprintf
    	(
	    Outf,
	    "%.0Lf-%02i-%02i %02i:%02i:%08.5Lf+0000 JD=%.7Lf TMSL=%Lf TMS=%Lf\n",
	    gyear(),
	    gmonth()+1,
	    gmday()+1,
	    ghour(),
	    gminute(),
	    gsecond(),
	    juliandate(),
	    _tmsl,
	    _tms()
    	);
    }

    //----------------------------------------------------------------------------------------------------------
    void
    dump() const
    {
    	printf
    	(
	    "_tmsl=%Lf; readyflags=0x%x; distortionflags=0x%x;\n",
	    _tmsl,
	    _readyflags,
	    _distortionflags
    	);
    }
};

